Public Class Form1
    Private m_ColumnIndexes As Collection
    Private m_ColumnNames As Collection

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Remove any existing items.
        lvwBooks.Items.Clear()

        ' Add data rows.
        ListViewMakeRow(lvwBooks, "Ready-to-Run Visual Basic Algorithms", "http://www.vb-helper.com/vba.htm", "0-471-24268-3", "http://www.vb-helper.com/vba.jpg", "395", "1998")
        ListViewMakeRow(lvwBooks, "Visual Basic Graphics Programming", "http://www.vb-helper.com/vbgp.htm", "0-472-35599-2", "http://www.vb-helper.com/vbgp.jpg", "712", "2000")
        ListViewMakeRow(lvwBooks, "Advanced Visual Basic Techniques", "http://www.vb-helper.com/avbt.htm", "0-471-18881-6", "http://www.vb-helper.com/avbt.jpg", "440", "1997")
        ListViewMakeRow(lvwBooks, "Custom Controls Library", "http://www.vb-helper.com/ccl.htm", "0-471-24267-5", "http://www.vb-helper.com/ccl.jpg", "684", "1998")
        ListViewMakeRow(lvwBooks, "Ready-to-Run Delphi Algorithms", "http://www.vb-helper.com/da.htm", "0-471-25400-2", "http://www.vb-helper.com/da.jpg", "398", "1998")
        ListViewMakeRow(lvwBooks, "Bug Proofing Visual Basic", "http://www.vb-helper.com/err.htm", "0-471-32351-9", "http://www.vb-helper.com/err.jpg", "397", "1999")
        ListViewMakeRow(lvwBooks, "Ready-to-Run Visual Basic Code Library", "http://www.vb-helper.com/vbcl.htm", "0-471-33345-X", "http://www.vb-helper.com/vbcl.jpg", "424", "1999")

        ' Remove any existing column headers.
        lvwBooks.Columns.Clear()

        ' Make the column headers.
        lvwBooks.Columns.Add("Title", 200, HorizontalAlignment.Left)
        lvwBooks.Columns.Add("URL", 200, HorizontalAlignment.Left)
        lvwBooks.Columns.Add("ISBN", 100, HorizontalAlignment.Left)
        lvwBooks.Columns.Add("Picture", 200, HorizontalAlignment.Left)
        lvwBooks.Columns.Add("Pages", 50, HorizontalAlignment.Right)
        lvwBooks.Columns.Add("Year", 50, HorizontalAlignment.Right)

        ' Record the initial column names.
        m_ColumnNames = New Collection()
        For i As Integer = 0 To lvwBooks.Columns.Count - 1
            m_ColumnNames.Add(lvwBooks.Columns(i).Text)
        Next i

        ' Record the initial column indexes.
        m_ColumnIndexes = New Collection()
        For i As Integer = 0 To lvwBooks.Columns.Count - 1
            m_ColumnIndexes.Add(i)
        Next i
    End Sub

    ' Make a ListView row.
    Private Sub ListViewMakeRow(ByVal lvw As ListView, ByVal item_title As String, ByVal ParamArray subitem_titles() As String)
        ' Make the item.
        Dim new_item As ListViewItem = lvw.Items.Add(item_title)

        ' Make the sub-items.
        For i As Integer = subitem_titles.GetLowerBound(0) To subitem_titles.GetUpperBound(0)
            new_item.SubItems.Add(subitem_titles(i))
        Next i
    End Sub

    ' Update the column order.
    Private Sub lvwBooks_ColumnReordered(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ColumnReorderedEventArgs) Handles lvwBooks.ColumnReordered
        Dim column_name As String = CStr(m_ColumnNames(e.OldDisplayIndex + 1))
        m_ColumnNames.Remove(e.OldDisplayIndex + 1)
        m_ColumnNames.Add(column_name, Before:=e.NewDisplayIndex + 1)

        Dim index As Integer = CInt(m_ColumnIndexes(e.OldDisplayIndex + 1))
        m_ColumnIndexes.Remove(e.OldDisplayIndex + 1)
        m_ColumnIndexes.Add(index, Before:=e.NewDisplayIndex + 1)

        ' Display the current name order.
        For i As Integer = 1 To m_ColumnIndexes.Count
            Debug.Write(CStr(m_ColumnNames(i)) & " ")
        Next i
        Debug.WriteLine("")

        ' Display the current index order.
        For i As Integer = 1 To m_ColumnIndexes.Count
            Debug.Write(CInt(m_ColumnIndexes(i)) & " ")
        Next i
        Debug.WriteLine("")
    End Sub
End Class
